import { RsbuildPlugin } from '@rsbuild/core';
import { ecmaVersion } from 'acorn';

type CheckSyntaxOptions = {
    /**
     * The target browser range of the project.
     * Its value is a standard browserslist array.
     */
    targets?: string[];
    /**
     * The minimum ECMAScript syntax version that can be used in the build artifact.
     * The priority of `ecmaVersion` is higher than `targets`.
     */
    exclude?: RegExp | RegExp[];
    /**
     * Used to exclude a portion of files during detection.
     * You can pass in one or more regular expressions to match the paths of source files.
     */
    ecmaVersion?: ecmaVersion;
};

type PluginCheckSyntaxOptions = CheckSyntaxOptions;
declare const PLUGIN_CHECK_SYNTAX_NAME = "rsbuild:check-syntax";
declare function pluginCheckSyntax(options?: PluginCheckSyntaxOptions): RsbuildPlugin;

export { PLUGIN_CHECK_SYNTAX_NAME, type PluginCheckSyntaxOptions, pluginCheckSyntax };
